#include "Button.h"

extern terminal term;
Ptr<Button> Button::create(int x1, int y1, int x2, int y2,
			   std::string name, Ptr<Action_base> a){
  return Ptr<Button>(new Button(x1, y1, x2, y2, name, a));
}
Ptr<Button> Button::create(int x, int y, std::string name, Ptr<Action_base> a){
  return Ptr<Button>(new Button(x, y, x + name.size() + 1, y + 2, name, a));
}
Button::Button(int x1, int y1, int x2, int y2,
	       std::string name, Ptr<Action_base> a):
  Component(x1, y1, x2, y2), name(name), action(a){
}


void Button::show(){
  term.savecur();
  for (int i = getUprl().second; i <= getLowr().second; i++){
    term.curmove(getUprl().first, i);
    for (int j = getUprl().first; j <= getLowr().first; j++)
      term << " " << curmove(j,i);
  }
  term.box(getUprl().first,
	   getUprl().second, 
	   getLowr().first,
	   getLowr().second);
  int xoffset; 
  int yoffset ;
  centralize(xoffset, yoffset, name.size());
  term << curmove(xoffset, yoffset) << name << restcur; 
}

bool Button::handle_event(Event eve){
  std::pair<int, int> curpos;
  std::pair<int, int> evepos;
  evepos.first = eve.whereX;
  evepos.second = eve.whereY;
  term.curget(curpos.first, curpos.second);
  if (!contains(evepos) && contains(curpos)){
    enter();
    return false;
  }
  else if (contains(evepos) && !contains(curpos)){
    leave();
    return false;
  }
  else if(contains(evepos) && eve.what == terminal::CTRLm){
    action->perform();
    return true;
  }
  else{
    return false;
  }
}

void Button::enter(){
  term.reverse();
  show();
  term.normal();
}

void Button::leave(){
  term.normal();
  show();
}
